diff -ur ORG/CMakeLists.txt ./CMakeLists.txt
--- ORG/CMakeLists.txt	2022-05-17 14:52:38.310001000 +0900
+++ ./CMakeLists.txt	2022-05-17 14:51:54.832866000 +0900
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.13.0 FATAL_ERROR)
 enable_testing()
 
 project(HPhi NONE)
diff -ur ORG/src/CMakeLists.txt ./src/CMakeLists.txt
--- ORG/src/CMakeLists.txt	2022-05-17 14:52:43.094335000 +0900
+++ ./src/CMakeLists.txt	2022-05-17 14:49:05.200427000 +0900
@@ -1,5 +1,5 @@
 # include guard
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 3.13.0)
 if(${CMAKE_PROJECT_NAME} STREQUAL "Project")
   message(FATAL_ERROR "cmake should be executed not for 'src' subdirectory, but for the top directory of HPhi.")
 endif(${CMAKE_PROJECT_NAME} STREQUAL "Project")
@@ -39,7 +39,8 @@
 ${STDFACE_DIR}/src/Wannier90.c)
 
 add_executable(HPhi ${SOURCES} ${SOURCES_LANCZOS} ${SOURCES_CG} ${SOURCES_TPQ} ${SOURCES_SPECTRUM} ${SOURCES_TEM} ${SOURCES_MLTPLY} ${SOURCES_DIAG} ${SOURCES_PHYS} ${SOURCES_STDFACE} ${SOURCES_COMMON})
-target_link_libraries(HPhi komega ${LAPACK_LIBRARIES} m)
+target_link_directories(HPhi PRIVATE ${CMAKE_Fortran_IMPLICIT_LINK_DIRECTORIES})
+target_link_libraries(HPhi komega ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES} ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES} m)
 if(MPI_FOUND)
   target_link_libraries(HPhi ${MPI_C_LIBRARIES})
 endif(MPI_FOUND)
diff -ur ORG/test/Ave_SS.py ./test/Ave_SS.py
--- ORG/test/Ave_SS.py	2022-05-17 14:52:39.292005000 +0900
+++ ./test/Ave_SS.py	2022-05-17 14:48:28.097472000 +0900
@@ -1,4 +1,4 @@
-import numpy as np
+import nlcpy as np
 import os
 import sys
 import copy
diff -ur ORG/test/te_hubbard_chain_interall.sh ./test/te_hubbard_chain_interall.sh
--- ORG/test/te_hubbard_chain_interall.sh	2022-05-17 14:52:39.285347000 +0900
+++ ./test/te_hubbard_chain_interall.sh	2022-05-17 14:48:28.127205000 +0900
@@ -2,7 +2,7 @@
 
 mkdir -p te_hubbard_chain_interall/
 cd te_hubbard_chain_interall
-python "$1/test/testTECalc.py" -p "../../src/HPhi" -mpi "${MPIRUN}"
+python3 "$1/test/testTECalc.py" -p "../../src/HPhi" -mpi "${MPIRUN}"
 
 # Check value: flct
 cat > reference.dat <<EOF
diff -ur ORG/test/te_hubbard_chain_interall_diagonal.sh ./test/te_hubbard_chain_interall_diagonal.sh
--- ORG/test/te_hubbard_chain_interall_diagonal.sh	2022-05-17 14:52:39.432399000 +0900
+++ ./test/te_hubbard_chain_interall_diagonal.sh	2022-05-17 14:48:28.149827000 +0900
@@ -2,7 +2,7 @@
 
 mkdir -p te_hubbard_chain_interall_diagonal/
 cd te_hubbard_chain_interall_diagonal
-python "$1/test/testTECalc.py" -p "../../src/HPhi" -mpi "${MPIRUN}" -t "Diagonal"
+python3 "$1/test/testTECalc.py" -p "../../src/HPhi" -mpi "${MPIRUN}" -t "Diagonal"
 
 # Check value: flct
 cat > reference.dat <<EOF
diff -ur ORG/test/te_kondo_chain_interall.sh ./test/te_kondo_chain_interall.sh
--- ORG/test/te_kondo_chain_interall.sh	2022-05-17 14:52:39.201629000 +0900
+++ ./test/te_kondo_chain_interall.sh	2022-05-17 14:48:28.190505000 +0900
@@ -2,7 +2,7 @@
 
 mkdir -p te_kondo_chain_interall/
 cd te_kondo_chain_interall
-python "$1/test/testTECalc.py" -p "../../src/HPhi" -mpi "${MPIRUN}" -m "Kondo"
+python3 "$1/test/testTECalc.py" -p "../../src/HPhi" -mpi "${MPIRUN}" -m "Kondo"
 
 # Check value: flct
 cat > reference.dat <<EOF
diff -ur ORG/test/te_spin_chain_interall.sh ./test/te_spin_chain_interall.sh
--- ORG/test/te_spin_chain_interall.sh	2022-05-17 14:52:39.616289000 +0900
+++ ./test/te_spin_chain_interall.sh	2022-05-17 14:48:28.240761000 +0900
@@ -2,7 +2,7 @@
 
 mkdir -p te_spin_chain_interall/
 cd te_spin_chain_interall
-python "$1/test/testTECalc.py" -p "../../src/HPhi" -mpi "${MPIRUN}" -m "Spin"
+python3 "$1/test/testTECalc.py" -p "../../src/HPhi" -mpi "${MPIRUN}" -m "Spin"
 
 # Check value: SS
 cat > reference.dat <<EOF
diff -ur ORG/test/testTECalc.py ./test/testTECalc.py
--- ORG/test/testTECalc.py	2022-05-17 14:52:38.957997000 +0900
+++ ./test/testTECalc.py	2022-05-17 14:48:28.255488000 +0900
@@ -9,7 +9,7 @@
 # -*- coding: utf-8 -*-
 import sys
 import os
-import numpy as np
+import nlcpy as np
 import shutil
 import subprocess
 import argparse
diff -ur ORG/tool/CMakeLists.txt ./tool/CMakeLists.txt
--- ORG/tool/CMakeLists.txt	2022-05-17 14:52:37.943604000 +0900
+++ ./tool/CMakeLists.txt	2022-05-17 14:48:28.271428000 +0900
@@ -8,7 +8,7 @@
 
 add_executable(greenr2k greenr2k.F90)
 add_executable(cTPQ cTPQ.F90)
-target_link_libraries(greenr2k ${LAPACK_LIBRARIES})
+target_link_libraries(greenr2k ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
 
 install(TARGETS greenr2k RUNTIME DESTINATION bin)
 #
diff -ur ORG/tool/cTPQ.F90 ./tool/cTPQ.F90
--- ORG/tool/cTPQ.F90	2022-05-17 14:52:37.678412000 +0900
+++ ./tool/cTPQ.F90	2022-05-17 14:48:28.291049000 +0900
@@ -5,6 +5,9 @@
 CONTAINS
   !
 SUBROUTINE read_modpara(nLan, nSite, nAve, Large, ss_rand, norm_rand)
+#if defined(__ve__)
+  USE F90_UNIX
+#endif
   !
 #if defined(FUJITSU)
   USE service_routines, ONLY : IARGC
